/* Copyright 2006 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef INTERSECTION_HH
#define INTERSECTION_HH

#include "Point.hh"
#include <vector>

namespace SharpConstruct
{
	class Intersection
	{
	public:
		Intersection( const Point3D& l,
			      const Normal3D& n )
		: location_( l ), normal_( n ), index_( -1 )
		{}

		const Point3D& Location() const
		{
			return location_;
		}
		const Normal3D& Normal() const
		{
			return normal_;
		}
		int Index() const
		{
			return index_;
		}
		void SetIndex( const int ndx )
		{
			index_ = ndx;
		}
	private:
		Point3D location_;
		Normal3D normal_;
		int index_;
	};

	typedef std::vector< Intersection > Intersections;
}

#endif
